(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     20832,        674]
NotebookOptionsPosition[     18508,        589]
NotebookOutlinePosition[     18883,        606]
CellTagsIndexPosition[     18840,        603]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Set Directory and Filename of the Input File", "Subsection"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{"SetDirectory", "[", 
  "\"\<C:\\Users\\ohtsuka\\Documents\\AutoGen\\AutoGenU\\agInvPend\>\"", 
  "]"}], "\[IndentingNewLine]", 
 RowBox[{"InpFile", "=", "\"\<inputInvPendC.m\>\""}]}], "Input",
 CellChangeTimes->{{3.526161431153847*^9, 3.526161479935133*^9}, {
   3.5261615266336184`*^9, 3.5261615430292473`*^9}, 3.5261769283054028`*^9},
 EmphasizeSyntaxErrors->True],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"StringForm", "::", "sfq"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\\"\\\\:672a\\\\:77e5\\\\:306e\\\\:30a8\\\
\\:30b9\\\\:30b1\\\\:30fc\\\\:30d7\\\\:6587\\\\:5b57\\\\:5217\\\\`1`\\\\:304c\
\\\\:3042\\\\:308a\\\\:307e\\\\:3059\\\\:ff0e\\\"\\)\[NoBreak]\:306e\:30d0\
\:30c3\:30af\:30af\:30a9\:30fc\:30c8\:304c\:30de\:30c3\:30c1\:3057\:307e\:305b\
\:3093\:ff0e \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/StringForm/sfq\\\", ButtonNote -> \
\\\"StringForm::sfq\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.526161480902334*^9, {3.5261615476936555`*^9, 3.526161574213702*^9}, 
   3.5261618734604273`*^9, 3.5261664869653597`*^9, 3.52617400053799*^9, 
   3.526176933531412*^9, 3.526176986103504*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"StringForm", "::", "sfq"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\\"\\\\:672a\\\\:77e5\\\\:306e\\\\:30a8\\\
\\:30b9\\\\:30b1\\\\:30fc\\\\:30d7\\\\:6587\\\\:5b57\\\\:5217\\\\`1`\\\\:304c\
\\\\:3042\\\\:308a\\\\:307e\\\\:3059\\\\:ff0e\\\"\\)\[NoBreak]\:306e\:30d0\
\:30c3\:30af\:30af\:30a9\:30fc\:30c8\:304c\:30de\:30c3\:30c1\:3057\:307e\:305b\
\:3093\:ff0e \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/StringForm/sfq\\\", ButtonNote -> \
\\\"StringForm::sfq\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.526161480902334*^9, {3.5261615476936555`*^9, 3.526161574213702*^9}, 
   3.5261618734604273`*^9, 3.5261664869653597`*^9, 3.52617400053799*^9, 
   3.526176933531412*^9, 3.526176986103504*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"StringForm", "::", "sfq"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\[NoBreak]\\!\\(\\\"\\\\:672a\\\\:77e5\\\\:306e\\\\:30a8\\\
\\:30b9\\\\:30b1\\\\:30fc\\\\:30d7\\\\:6587\\\\:5b57\\\\:5217\\\\`1`\\\\:304c\
\\\\:3042\\\\:308a\\\\:307e\\\\:3059\\\\:ff0e\\\"\\)\[NoBreak]\:306e\:30d0\
\:30c3\:30af\:30af\:30a9\:30fc\:30c8\:304c\:30de\:30c3\:30c1\:3057\:307e\:305b\
\:3093\:ff0e \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/StringForm/sfq\\\", ButtonNote -> \
\\\"StringForm::sfq\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.526161480902334*^9, {3.5261615476936555`*^9, 3.526161574213702*^9}, 
   3.5261618734604273`*^9, 3.5261664869653597`*^9, 3.52617400053799*^9, 
   3.526176933531412*^9, 3.526176986103504*^9}],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"General", "::", "stop"}], "MessageName"], 
  RowBox[{
  ":", " "}], "\<\"\:3053\:306e\:8a08\:7b97\:4e2d\:306b\:ff0c\[NoBreak]\\!\\(\
\\*StyleBox[\\(StringForm :: sfq\\), \\\"MessageName\\\"]\\)\[NoBreak]\:306e\
\:3053\:308c\:4ee5\:4e0a\:306e\:51fa\:529b\:306f\:8868\:793a\:3055\:308c\:307e\
\:305b\:3093\:ff0e \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\
\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/stop\\\", ButtonNote -> \
\\\"General::stop\\\"]\\)\"\>"}]], "Message", "MSG",
 CellChangeTimes->{
  3.526161480902334*^9, {3.5261615476936555`*^9, 3.526161574213702*^9}, 
   3.5261618734604273`*^9, 3.5261664869653597`*^9, 3.52617400053799*^9, 
   3.526176933531412*^9, 3.5261769861191044`*^9}],

Cell[BoxData["\<\"C:\\\\Users\\\\ohtsuka\\\\Documents\\\\AutoGen\\\\AutoGenU\\\
\\agInvPend\"\>"], "Output",
 CellChangeTimes->{
  3.5261614809491343`*^9, {3.5261615477092557`*^9, 3.526161574213702*^9}, 
   3.5261618734760275`*^9, 3.5261664869809594`*^9, 3.5261740006159906`*^9, 
   3.526176933593812*^9, 3.5261769861191044`*^9}],

Cell[BoxData["\<\"inputInvPendC.m\"\>"], "Output",
 CellChangeTimes->{
  3.5261614809491343`*^9, {3.5261615477092557`*^9, 3.526161574213702*^9}, 
   3.5261618734760275`*^9, 3.5261664869809594`*^9, 3.5261740006159906`*^9, 
   3.526176933593812*^9, 3.5261769861191044`*^9}]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Functions for C Code Generation", "Section",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Differentiation by a Vector:  Dv", "Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Dv", "[", 
   RowBox[{"f_", ",", "x_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"j", ",", "ans"}], "}"}], ",", 
    RowBox[{
     RowBox[{"ans", "=", 
      RowBox[{"Table", "[", 
       RowBox[{
        RowBox[{
         SubscriptBox["\[PartialD]", 
          RowBox[{
          "x", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}]], "f"}],
         ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", 
          RowBox[{"Length", "[", "x", "]"}]}], "}"}]}], "]"}]}], ";", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", 
         RowBox[{"Dimensions", "[", "ans", "]"}], "]"}], "\[NotEqual]", "1"}],
        ",", 
       RowBox[{"ans", "=", 
        RowBox[{"Transpose", "[", "ans", "]"}]}]}], "]"}], ";", "ans"}]}], 
   "]"}]}]], "Input",
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Constuction of an n by n Symmetric Matrix from a Vector", \
"Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"Sym", "[", 
   RowBox[{"v_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"i", ",", "j", ",", "iv", ",", "ans"}], "}"}], ",", 
    RowBox[{
     RowBox[{"ans", "=", 
      RowBox[{"Table", "[", 
       RowBox[{"0", ",", 
        RowBox[{"{", 
         RowBox[{"i", ",", "n"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"j", ",", "n"}], "}"}]}], "]"}]}], ";", 
     RowBox[{"iv", "=", "1"}], ";", 
     RowBox[{"i", "=", "0"}], ";", 
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{"ans", "\[LeftDoubleBracket]", 
            RowBox[{"j", ",", 
             RowBox[{"j", "+", "i"}]}], "\[RightDoubleBracket]"}], "=", 
           RowBox[{
           "v", "\[LeftDoubleBracket]", "iv", "\[RightDoubleBracket]"}]}], 
          ";", 
          RowBox[{
           RowBox[{"ans", "\[LeftDoubleBracket]", 
            RowBox[{
             RowBox[{"j", "+", "i"}], ",", "j"}], "\[RightDoubleBracket]"}], 
           "=", 
           RowBox[{
           "v", "\[LeftDoubleBracket]", "iv", "\[RightDoubleBracket]"}]}], 
          ";", 
          RowBox[{"iv", "++"}]}], ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"n", "-", "i"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], ";", "ans"}]}], 
   "]"}]}]], "Input",
 AspectRatioFixed->True]
}, Open  ]],

Cell[CellGroupData[{

Cell["Construction of a Vector from an n by n Symmetric Matrix", \
"Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{
  RowBox[{"DeSym", "[", 
   RowBox[{"S_", ",", "n_"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"i", ",", "j", ",", 
      RowBox[{"ans", "=", 
       RowBox[{"{", "}"}]}]}], "}"}], ",", 
    RowBox[{
     RowBox[{"Do", "[", 
      RowBox[{
       RowBox[{"Do", "[", 
        RowBox[{
         RowBox[{"AppendTo", "[", 
          RowBox[{"ans", ",", 
           RowBox[{"S", "\[LeftDoubleBracket]", 
            RowBox[{"j", ",", 
             RowBox[{"j", "+", "i"}]}], "\[RightDoubleBracket]"}]}], "]"}], 
         ",", 
         RowBox[{"{", 
          RowBox[{"j", ",", 
           RowBox[{"n", "-", "i"}]}], "}"}]}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "0", ",", 
         RowBox[{"n", "-", "1"}]}], "}"}]}], "]"}], ";", "ans"}]}], 
   "]"}]}]], "Input",
 AspectRatioFixed->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["User Settings", "Section"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"Off", "[", 
   RowBox[{"General", "::", "spell"}], "]"}], "\[IndentingNewLine]", 
  RowBox[{"(*", " ", 
   RowBox[{"Default", " ", "Values"}], " ", "*)"}]}], "\n", 
 RowBox[{
  RowBox[{"SimplifyLevel", "=", "0"}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Precondition", "=", "0"}], ";"}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"Get", "[", "InpFile", "]"}], " ", 
  RowBox[{"(*", " ", 
   RowBox[{"Read", " ", "Input", " ", "File"}], " ", "*)"}]}]], "Input"],

Cell[BoxData[{
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"dimx", " ", "!=", " ", 
    RowBox[{"Length", "[", "fxu", "]"}]}], ",", " ", 
   RowBox[{
    RowBox[{
    "\"\<Warning! Dimension Missmatch in dimx and fxu.\>\"", ">>", 
     "outfile"}], ";", 
    RowBox[{
     StyleBox["Abort", "MR"], 
     StyleBox["[", "MR"], " ", 
     StyleBox["]", "MR"]}], ";"}]}], "]"}], "\n", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Length", "[", "MyVarNames", "]"}], "!=", " ", 
    RowBox[{"Length", "[", "MyVarValues", "]"}]}], ",", " ", 
   RowBox[{
    RowBox[{
    "\"\<Warning! Dimension Missmatch in MyVarNames and MyVarValues\>\"", ">>",
      "outfile"}], ";", 
    RowBox[{
     StyleBox["Abort", "MR"], 
     StyleBox["[", "MR"], " ", 
     StyleBox["]", "MR"]}], ";"}]}], "]"}], "\n", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", "MyArrNames", "]"}], "!=", " ", 
      RowBox[{"Length", "[", "MyArrDims", "]"}]}], ")"}], "||", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Length", "[", "MyArrDims", "]"}], "!=", " ", 
      RowBox[{"Length", "[", "MyArrValues", "]"}]}], ")"}]}], ",", " ", 
   RowBox[{
    RowBox[{
    "\"\<Warning! Dimension Missmatch in MyArrNames, MyArrDims and \
MyArrValues\>\"", ">>", "outfile"}], ";", 
    RowBox[{
     StyleBox["Abort", "MR"], 
     StyleBox["[", "MR"], " ", 
     StyleBox["]", "MR"]}], ";"}]}], "]"}], "\n"}], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Generate RHC Algorithm", "Section",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[CellGroupData[{

Cell["Euler-Lagrange Equations", "Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"H", "=", 
   RowBox[{"L", "+", 
    RowBox[{"lmdv", ".", "fxu"}], "+", 
    RowBox[{"muv", ".", "Cxu"}]}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"uv", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"uv", ",", "muv"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"dimuc", "=", 
   RowBox[{"dimu", "+", "dimc"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Hx", "=", 
   RowBox[{"Dv", "[", 
    RowBox[{"H", ",", "xv"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Hu", "=", 
   RowBox[{"Dv", "[", 
    RowBox[{"H", ",", "uv"}], "]"}]}], ";"}], "\n", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"SimplifyLevel", ">", "0"}], ",", 
   RowBox[{
    RowBox[{"Hx", "=", 
     RowBox[{"Simplify", "[", "Hx", "]"}]}], ";", 
    RowBox[{"Hu", "=", 
     RowBox[{"Simplify", "[", "Hu", "]"}]}], ";"}]}], "]"}], "\n", 
 RowBox[{
  RowBox[{"dlmddt", "=", 
   RowBox[{"-", "Hx"}]}], ";"}]}], "Input",
 AspectRatioFixed->True]
}, Open  ]],

Cell[BoxData[
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"Precondition", "==", "1"}], ",", "\n", "\t", 
   RowBox[{
    RowBox[{"Huu", "=", 
     RowBox[{"Dv", "[", 
      RowBox[{"Hu", ",", "uv"}], "]"}]}], ";", "\n", "\t", 
    RowBox[{"Hu", "=", 
     RowBox[{"LinearSolve", "[", 
      RowBox[{"Huu", ",", "Hu"}], "]"}]}], ";", "\n", "\t", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{"SimplifyLevel", ">", "0"}], ",", 
      RowBox[{"Hu", "=", 
       RowBox[{"Simplify", "[", "Hu", "]"}]}]}], "]"}], ";"}]}], "\n", 
  "]"}]], "Input"],

Cell[CellGroupData[{

Cell["Boudary Conditions", "Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"phix", "=", 
   RowBox[{"Dv", "[", 
    RowBox[{"phi", ",", "xv"}], "]"}]}], ";"}], "\n", 
 RowBox[{"If", "[", 
  RowBox[{
   RowBox[{"SimplifyLevel", ">", "0"}], ",", 
   RowBox[{
    RowBox[{"phix", "=", 
     RowBox[{"Simplify", "[", "phix", "]"}]}], ";"}]}], "]"}]}], "Input",
 AspectRatioFixed->True]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell["Generate C Code", "Section",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[
 RowBox[{"<<", "Format2`"}]], "Input"],

Cell[BoxData[
 RowBox[{"<<", "Optimize2`"}]], "Input"],

Cell[CellGroupData[{

Cell["Conversion of Arrays", "Subsubsection",
 Evaluatable->False,
 AspectRatioFixed->True],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ArrNames", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"MyArrNames", ",", 
     RowBox[{"{", 
      RowBox[{
      "\"\<x\>\"", ",", "\"\<lmd\>\"", ",", "\"\<u\>\"", ",", "\"\<p\>\"", 
       ",", "\"\<dx\>\"", ",", "\"\<dlmd\>\"", ",", "\"\<hu\>\""}], "}"}]}], 
    "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ArrDims", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"MyArrDims", ",", 
     RowBox[{"{", 
      RowBox[{
      "dimx", ",", "dimx", ",", "dimuc", ",", "dimp", ",", "dimx", ",", 
       "dimx", ",", "dimuc"}], "}"}]}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"ArrCnv", "=", 
   RowBox[{"{", "}"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Do", "[", 
   RowBox[{
    RowBox[{"ArrCnv", "=", 
     RowBox[{"Join", "[", 
      RowBox[{"ArrCnv", ",", 
       RowBox[{"Table", "[", 
        RowBox[{
         RowBox[{
          RowBox[{
           RowBox[{
           "ArrNames", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}],
            "<>", "\"\<[\>\"", "<>", 
           RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<]\>\""}], 
          "\[Rule]", 
          RowBox[{
           RowBox[{
           "ArrNames", "\[LeftDoubleBracket]", "j", "\[RightDoubleBracket]"}],
            "<>", "\"\<[\>\"", "<>", 
           RowBox[{"ToString", "[", 
            RowBox[{"i", "-", "1"}], "]"}], "<>", "\"\<]\>\""}]}], ",", 
         RowBox[{"{", 
          RowBox[{"i", ",", 
           RowBox[{
           "ArrDims", "\[LeftDoubleBracket]", "j", 
            "\[RightDoubleBracket]"}]}], "}"}]}], "]"}]}], "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"j", ",", 
      RowBox[{"Length", "[", "ArrNames", "]"}]}], "}"}]}], "]"}], 
  ";"}]}], "Input",
 AspectRatioFixed->True]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"Optimize", ",", 
    RowBox[{"OptimizeVariable", "\[Rule]", 
     RowBox[{"{", 
      RowBox[{"o", ",", "Array"}], "}"}]}], ",", 
    RowBox[{"OptimizeNull", "->", 
     RowBox[{"Prepend", "[", 
      RowBox[{
       RowBox[{"ToExpression", "[", "ArrNames", "]"}], ",", "List"}], "]"}]}],
     ",", 
    RowBox[{"OptimizeCoefficients", "\[Rule]", "True"}], ",", 
    RowBox[{"OptimizeProcedure", "\[Rule]", "False"}]}], "]"}], 
  ";"}]], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"lept", "=", 
   RowBox[{"Length", "[", 
    RowBox[{
     RowBox[{"Optimize", "[", "pt", "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"leph", "=", 
   RowBox[{"Length", "[", 
    RowBox[{
     RowBox[{"Optimize", "[", "phix", "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"lexp", "=", 
   RowBox[{"Length", "[", 
    RowBox[{
     RowBox[{"Optimize", "[", "fxu", "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"lelp", "=", 
   RowBox[{"Length", "[", 
    RowBox[{
     RowBox[{"Optimize", "[", "dlmddt", "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"lehu", "=", 
   RowBox[{"Length", "[", 
    RowBox[{
     RowBox[{"Optimize", "[", "Hu", "]"}], "[", 
     RowBox[{"[", "1", "]"}], "]"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"leno", "=", 
   RowBox[{"Max", "[", 
    RowBox[{"{", 
     RowBox[{"lept", ",", "leph", ",", "lexp", ",", "lelp", ",", "lehu"}], 
     "}"}], "]"}]}], ";"}]}], "Input"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"ArrCnv2", "=", "ArrCnv"}], ";"}], "\n", 
 RowBox[{"Do", "[", "\n", "\t", 
  RowBox[{"ArrCnv2", "=", 
   RowBox[{"Join", "[", 
    RowBox[{"ArrCnv2", ",", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"\"\<o[\>\"", "<>", 
         RowBox[{"ToString", "[", "i", "]"}], "<>", "\"\<]\>\""}], "\[Rule]", 
        RowBox[{"\"\<o[\>\"", "<>", 
         RowBox[{"ToString", "[", 
          RowBox[{"i", "-", "1"}], "]"}], "<>", "\"\<]\>\""}]}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "leno"}], "}"}]}], "]"}]}], "]"}]}], "\n", 
  "]"}]}], "Input"],

Cell[BoxData[
 RowBox[{
  RowBox[{"SetOptions", "[", 
   RowBox[{"CAssign", ",", 
    RowBox[{"AssignOptimize", "->", "True"}], ",", 
    RowBox[{"AssignPrecision", "\[Rule]", "10"}], ",", 
    RowBox[{"AssignReplace", "->", "ArrCnv2"}], ",", 
    RowBox[{"AssignToArray", "->", 
     RowBox[{"ToExpression", "[", "ArrNames", "]"}]}], ",", 
    RowBox[{"AssignIndent", "\[Rule]", "\"\<    \>\""}]}], "]"}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.5261616981619196`*^9, 3.526161698770321*^9}}],

Cell[CellGroupData[{

Cell["Output to File", "Subsubsection"],

Cell[BoxData[{
 RowBox[{
  RowBox[{"outfile", "=", 
   RowBox[{"StringJoin", "[", 
    RowBox[{"outfn", ",", "\"\<.c\>\""}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"Splice", "[", 
   RowBox[{"\"\<AutoGenU.mc\>\"", ",", "outfile", ",", 
    RowBox[{"FormatType", "->", "OutputForm"}]}], "]"}], ";"}]}], "Input",
 AspectRatioFixed->True]
}, Open  ]]
}, Closed]]
},
CellGrouping->Manual,
WindowSize->{675, 745},
WindowMargins->{{2, Automatic}, {0, Automatic}},
FrontEndVersion->"8.0 for Microsoft Windows (32-bit) (2010\:5e7412\:67082\
\:65e5)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[579, 22, 66, 0, 36, "Subsection"],
Cell[CellGroupData[{
Cell[670, 26, 391, 7, 52, "Input"],
Cell[1064, 35, 865, 16, 20, "Message"],
Cell[1932, 53, 865, 16, 20, "Message"],
Cell[2800, 71, 865, 16, 20, "Message"],
Cell[3668, 89, 790, 15, 20, "Message"],
Cell[4461, 106, 329, 5, 30, "Output"],
Cell[4793, 113, 271, 4, 30, "Output"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5113, 123, 96, 2, 71, "Section",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[5234, 129, 103, 2, 27, "Subsubsection",
 Evaluatable->False],
Cell[5340, 133, 895, 29, 52, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6272, 167, 128, 3, 27, "Subsubsection",
 Evaluatable->False],
Cell[6403, 172, 1540, 46, 92, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7980, 223, 129, 3, 27, "Subsubsection",
 Evaluatable->False],
Cell[8112, 228, 874, 28, 52, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[9035, 262, 32, 0, 41, "Section"],
Cell[9070, 264, 329, 9, 92, "Input"],
Cell[9402, 275, 164, 4, 31, "Input"],
Cell[9569, 281, 1446, 44, 212, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[11052, 330, 87, 2, 41, "Section",
 Evaluatable->False],
Cell[CellGroupData[{
Cell[11164, 336, 95, 2, 27, "Subsubsection",
 Evaluatable->False],
Cell[11262, 340, 933, 32, 152, "Input"]
}, Open  ]],
Cell[12210, 375, 548, 16, 112, "Input"],
Cell[CellGroupData[{
Cell[12783, 395, 89, 2, 27, "Subsubsection",
 Evaluatable->False],
Cell[12875, 399, 341, 11, 52, "Input"]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[13265, 416, 80, 2, 41, "Section",
 Evaluatable->False],
Cell[13348, 420, 52, 1, 31, "Input"],
Cell[13403, 423, 54, 1, 31, "Input"],
Cell[CellGroupData[{
Cell[13482, 428, 91, 2, 27, "Subsubsection",
 Evaluatable->False],
Cell[13576, 432, 1722, 51, 192, "Input"]
}, Open  ]],
Cell[15313, 486, 512, 14, 72, "Input"],
Cell[15828, 502, 1127, 36, 132, "Input"],
Cell[16958, 540, 619, 17, 152, "Input"],
Cell[17580, 559, 494, 11, 72, "Input"],
Cell[CellGroupData[{
Cell[18099, 574, 39, 0, 27, "Subsubsection"],
Cell[18141, 576, 339, 9, 52, "Input"]
}, Open  ]]
}, Closed]]
}
]
*)

(* End of internal cache information *)
